if($Swol_MeleeVersion >= 1)
	return;
$Swol_MeleeVersion = 1;
package swol_swolMelee
{
	function swolMelee_onFire(%db,%pl,%slot)
	{
		if(%pl.meleeHealth[%db.item] $= "")
			%pl.meleeHealth[%db.item] = %db.item.meleeHealth;
		
		%mask = ($TypeMasks::FxBrickObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::TerrainObjectType);
		%search = containerRayCast(%pl.getEyePoint(),vectorAdd(%pl.getEyePoint(),vectorScale(%pl.getMuzzleVector(%slot),%db.item.meleeRange)),%mask,%pl);
		%victim = getWord(%search,0);
		if(%db.item.meleeSound_SwingCnt != 0)
			serverPlay3d(%db.item.meleeSound_Swing[getRandom(0,%db.item.meleeSound_SwingCnt-1)],%pl.getPosition());
		if(isObject(%victim))
		{
			%hit = getWords(%search,1,3);
			%pl.meleeHealth[%db.item]--;
			if(%pl.meleeHealth[%db.item] <= 0)
			{
				if(isObject(%db.item.meleeExplosion_Break))
				{
					%p = new Projectile()
					{
						datablock = %db.item.meleeExplosion_Break;
						initialPosition = %hit;
						sourceObject = %pl;
						sourceSlot = %slot;
						client = %pl.client;
					};
					%p.explode();
				}
				if(%db.item.meleeSound_BreakCnt != 0)
					serverPlay3d(%db.item.meleeSound_Break[getRandom(0,%db.item.meleeSound_BreakCnt-1)],%hit);
				
				%pl.tool[%pl.currTool] = 0;
				if(isObject(%cl = %pl.client))
					messageClient(%cl,'MsgItemPickup','',%pl.currTool,0,1);
				%pl.unMountImage(%slot);
				if(isFunction(%db.getName(),callback_break))
					%db.callback_break(%pl,%slot,%pl.currTool);
				%smash = 1;
			}
			else
			{
				if(%db.item.meleeSound_HitCnt != 0)
					serverPlay3d(%db.item.meleeSound_Hit[getRandom(0,%db.item.meleeSound_HitCnt-1)],%hit);
			}
			if(%victim.getClassName() $= "Player" || %victim.getClassName() $= "AiPlayer")
			{
				if(isObject(%cl = %pl.client))
				{
					if(minigameCanDamage(%cl,%victim))
					{
						%victim.damage(%p,%victim.getPosition(),(%smash ? %db.item.meleeDamageBreak : %db.item.meleeDamageHit),$DamageType::Chair);
						if(isFunction(%db.getName(),callback_hitPlayer))
							%db.callback_hitPlayer(%pl,%slot,%victim,%smash);
					}
				}
			}
			if(isFunction(%db.getName(),callback_hit))
				%db.callback_hit(%pl,%slot);
			if(isObject(%db.item.meleeExplosion_Hit))
			{
				%p = new Projectile()
				{
					datablock = %db.item.meleeExplosion_Hit;
					initialPosition = %hit;
					sourceObject = %pl;
					sourceSlot = %slot;
					client = %pl.client;
				};
				%p.explode();
			}
		}
	}
	function serverCmdDropTool(%cl,%slot)
	{
		if(!isObject(%pl = %cl.player))
			return parent::servercmdDropTool(%cl,%slot);
		if(!isObject(%tool = %pl.tool[%slot]))
			return parent::servercmdDropTool(%cl,%slot);
		if(%tool.meleeHealth !$= "")
			$MeleeToolHealthMod = %pl.meleeHealth[%tool.getName()];
		return parent::servercmdDropTool(%cl,%slot);
	}
	function ItemData::onAdd(%db,%item)
	{
		if($MeleeToolHealthMod !$= "")
		{
			echo($MeleeToolHealthMod);
			%item.meleeHealth = $MeleeToolHealthMod;
			$MeleeToolHealthMod = "";
		}
		parent::onAdd(%db,%item);
	}
	function player::pickup(%pl,%item)
	{
		if(%item.meleeHealth !$= "")
			%pl.meleeHealth[%item.getDatablock().getName()] = %item.meleeHealth;
		else if(%item.getDatablock().meleeHealth !$= "")
			%pl.meleeHealth[%item.getDatablock().getName()] = %item.getDatablock().meleeHealth;
		parent::pickup(%pl,%item);
	}
};
activatePackage(swol_swolMelee);