exec("./Support_SwolMelee.cs");
AddDamageType("Chair",   '%1 <bitmap:Add-ons/Weapon_WoodChair/ci_chair>',    '%2 <bitmap:Add-ons/Weapon_WoodChair/ci_chair> %1',0.75,1);
if($Pref::WoodChair::MeleeDmgHit $= "") $Pref::WoodChair::MeleeDmgHit = 100;
if($Pref::WoodChair::MeleeDmgBreak $= "") $Pref::WoodChair::MeleeDmgBreak = 100;
if($Pref::WoodChair::MeleeHealth $= "") $Pref::WoodChair::MeleeHealth = 3;
datablock AudioProfile(chairSmash1Sound)
{
	filename    = "./smash1.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(chairSmash2Sound : chairSmash1Sound)
{
	filename    = "./smash2.wav";
};
datablock AudioProfile(chairSwing1Sound : chairSmash1Sound)
{
	filename    = "./swing1.wav";
};
datablock AudioProfile(chairSwing2Sound : chairSmash1Sound)
{
	filename    = "./swing2.wav";
};
datablock AudioProfile(chairHit1Sound : chairSmash1Sound)
{
	filename    = "./hit1.wav";
};
datablock AudioProfile(chairHit2Sound : chairSmash1Sound)
{
	filename    = "./hit2.wav";
};
datablock AudioProfile(chairScreamSound : chairSmash1Sound)
{
	filename    = "./scream.wav";
};
datablock DebrisData(chairFragDebris)
{
	shapeFile 			= "./debris_frag.dts";
	lifetime 			= 2.8;
	spinSpeed			= 1200.0;
	minSpinSpeed 		= -3600.0;
	maxSpinSpeed 		= 3600.0;
	elasticity 			= 0.5;
	friction 			= 0.2;
	numBounces 			= 3;
	staticOnMaxBounce 	= true;
	snapOnMaxBounce 	= false;
	fade 				= true;
	gravModifier 		= 4;
};
datablock DebrisData(chairSeat1Debris :chairFragDebris)
{
	shapeFile = "./debris_seat1.dts";
};
datablock DebrisData(chairSeat2Debris :chairFragDebris)
{
	shapeFile = "./debris_seat2.dts";
};
datablock DebrisData(chairSeat3Debris :chairFragDebris)
{
	shapeFile = "./debris_seat3.dts";
};
datablock DebrisData(chairRestDebris :chairFragDebris)
{
	shapeFile 				= "./debris_rest.dts";
	spinSpeed				= 300.0;
	minSpinSpeed 			= -1200.0;
	maxSpinSpeed 			= 1200.0;
};
datablock DebrisData(chairLegDebris :chairFragDebris)
{
	shapeFile 				= "./debris_leg.dts";
	spinSpeed				= 300.0;
	minSpinSpeed 			= -1200.0;
	maxSpinSpeed 			= 1200.0;
};
datablock ExplosionData(chairSeat1Explosion)
{
	debris 					= chairSeat1Debris;
	debrisNum 				= 3;
	debrisNumVariance 		= 1;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 180;
	debrisVelocity 			= 12;
	debrisVelocityVariance 	= 6;
};
datablock ExplosionData(chairSeat2Explosion : chairSeat1Explosion)
{
	debris 					= chairSeat2Debris;
};
datablock ExplosionData(chairSeat3Explosion : chairSeat1Explosion)
{
	debris 					= chairSeat2Debris;
	debrisNum 				= 4;
	debrisNumVariance 		= 2;
};
datablock ExplosionData(chairRestExplosion : chairSeat1Explosion)
{
	debris 					= chairRestDebris;
	debrisNum 				= 6;
	debrisNumVariance 		= 4;
};
datablock ExplosionData(chairLegExplosion : chairSeat1Explosion)
{
	debris 					= chairLegDebris;
	debrisNum 				= 6;
	debrisNumVariance 		= 4;
};
datablock ExplosionData(chairFragExplosion : chairSeat1Explosion)
{
	debris 					= chairFragDebris;
	debrisNum 				= 12;
	debrisNumVariance 		= 8;
};
datablock ExplosionData(chairExplosion)
{
	debris 					= chairFragDebris;
	debrisNum 				= 12;
	debrisNumVariance 		= 8;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 180;
	debrisVelocity 			= 12;
	debrisVelocityVariance 	= 6;
	explosionShape 			= "";
	lifeTimeMS 				= 150;
	subExplosion[0] 		= chairSeat1Explosion;
	subExplosion[1] 		= chairSeat2Explosion;
	subExplosion[2] 		= chairSeat3Explosion;
	subExplosion[3] 		= chairRestExplosion;
	subExplosion[4] 		= chairLegExplosion;
	faceViewer     			= true;
	explosionScale 			= "1 1 1";
	shakeCamera 			= true;
	camShakeFreq 			= "10.0 11.0 10.0";
	camShakeAmp 			= "3.0 10.0 3.0";
	camShakeDuration 		= 0.1;
	camShakeRadius 			= 20.0;
};
datablock ProjectileData(chairProjectile)
{
	explosion = chairExplosion;
};
datablock ParticleData(chairExplosionParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 0.4;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/cloud";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]			= "0.8 0.8 0.6 0.3";
	colors[1]			= "0.8 0.8 0.6 0.0";
	sizes[0]			= 1.25;
	sizes[1]			= 2.25;

	useInvAlpha = true;
};

datablock ParticleEmitterData(chairExplosionEmitter)
{
	ejectionPeriodMS	= 1;
	periodVarianceMS	= 0;
	ejectionVelocity	= 4;
	velocityVariance	= 1.0;
	ejectionOffset  	= 0.0;
	thetaMin			= 89;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= chairExplosionParticle;
};

datablock ExplosionData(chairHitExplosion)
{
	debris 					= chairFragDebris;
	debrisNum 				= 12;
	debrisNumVariance 		= 8;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 180;
	debrisVelocity 			= 12;
	debrisVelocityVariance 	= 6;
	explosionShape 			= "";
	particleEmitter 		= chairExplosionEmitter;
	particleDensity 		= 10;
	particleRadius 			= 0.2;
	lifeTimeMS 				= 150;
	faceViewer     			= true;
	explosionScale 			= "1 1 1";
	shakeCamera 			= true;
	camShakeFreq 			= "10.0 11.0 10.0";
	camShakeAmp 			= "3.0 10.0 3.0";
	camShakeDuration 		= 0.1;
	camShakeRadius 			= 20.0;
};
datablock ProjectileData(chairHitProjectile)
{
	explosion = chairHitExplosion;
};
datablock ItemData(chairItem)
{
	category 			= "Weapon";
	className 			= "Weapon";

	shapeFile 			= "./chair.dts";
	rotate 				= false;
	mass 				= 1;
	density 			= 0.2;
	elasticity 			= 0.2;
	friction 			= 0.6;
	emap 				= true;

	uiName 				= "Chair";
	iconName 			= "./icon_chair";
	doColorShift 		= true;
	colorShiftColor 	= "0.56 0.4 0.2 1";

	image 				= chairImage;
	canDrop 			= true;
	
	meleeRange			= 3;
	meleeHealth			= $Pref::WoodChair::MeleeHealth;
	meleeDamageHit		= $Pref::WoodChair::MeleeDmgHit;
	meleeDamageBreak	= $Pref::WoodChair::MeleeDmgBreak;
	
	meleeSound_Swing[0] = "chairSwing1Sound";
	meleeSound_Swing[1] = "chairSwing2Sound";
	meleeSound_SwingCnt = 2;
	
	meleeSound_Hit[0] = "chairHit1Sound";
	meleeSound_Hit[1] = "chairHit2Sound";
	meleeSound_HitCnt = 2;
	
	meleeSound_Break[0] = "chairSmash1Sound";
	meleeSound_Break[1] = "chairSmash2Sound";
	meleeSound_BreakCnt = 2;
	
	meleeExplosion_Hit = "chairHitProjectile";
	meleeExplosion_Break = "chairProjectile";
};
datablock ShapeBaseImageData(chairImage)
{
	shapeFile 			= "./chair.dts";
	emap 				= true;

	mountPoint 			= 0;
	offset 				= "-0.53 0.3 0.72";
	eyeOffset 			= "0 0 0";
	rotation 			= "0 1 0 180";
	correctMuzzleVector = false;
	projectile 			= chairProjectile;
	projectileType 		= projectile;

	doColorShift 		= chairItem.doColorShift;
	colorShiftColor 	= chairItem.colorShiftColor;
	className 			= "WeaponImage";
	item 				= chairItem;
	armReady 			= true;
	melee				= true;
	
	stateName[0] 					= "Activate";
	stateTimeoutValue[0] 			= 0.5;
	stateTransitionOnTimeout[0] 	= "Ready";
	
	stateName[1] 					= "Ready";
	stateTransitionOnTriggerDown[1] = "Swing";
	
	stateName[2] 					= "Swing";
	stateScript[2] 					= "onFire";
	stateFire[2] 					= true;
	stateTransitionOnTimeout[2] 	= "Ready";
	stateTimeoutValue[2] 			= 0.48;
};
function chairImage::onFire(%db,%pl,%slot)
{
	swolMelee_onFire(%db,%pl,%slot);
	%pl.playThread(3,shiftDown);
}
function chairImage::callback_break(%db,%pl,%slot,%currTool)
{
	%pl.playThread(1,activate2);
	%pl.playThread(2,root);
}
function chairImage::callback_hitPlayer(%db,%pl,%slot,%victim,%smash)
{
	if(getRandom(0,20) == 0 && %smash)
	{
		%victim.setVelocity(getWords(vectorScale(%pl.getEyeVector(),getRandom(15,25)),0,1) SPC getRandom(3,6));
		serverPlay3d("chairScreamSound",%victim.getPosition());
	}
}
function chairImage::onMount(%db,%pl,%slot)
{
	parent::onMount(%db,%pl,%slot);
	%pl.playThread(2,armReadyLeft);
	%pl.setArmThread(land);
}
function chairImage::onUnMount(%db,%pl,%slot)
{
	%pl.setArmThread(look);
	%pl.playThread(2,root);
	parent::onUnMount(%db,%pl,%slot);
}